const baseMeta = [
  { id: 'chatset', meta: 'charset="UTF-8"' },
  { id: 'keywords', meta: 'name="keywords" content="vivid, kevisual, envision, micro-app"' },
  { id: 'viewport', meta: 'name="viewport" content="width=device-width, initial-scale=1.0"' },
  { id: 'author', meta: 'name="author" content="kevisual"' },
  { id: 'description', meta: 'name="description" content="A micro-app framework"' },
];
class HTMLWrapper {
  metaEl: { id: string; meta: string }[] = [];
  title: string;
  version: string;
  lang: string = 'zh-CN'; // Default value
  content: string;
  constructor() {
    this.metaEl = baseMeta;
    console.log('HTMLWrapper constructor');
  }
  setContent(content: string) {
    this.content = content;
  }
}

const getHTMLWrapper = (htmlWrapper: HTMLWrapper) => {
  const { version, lang, title, content } = htmlWrapper;
  const metaEl = htmlWrapper.metaEl || [];
  const metaStr = metaEl
    .map((meta) => {
      return `<meta id="${meta.id}" ${meta.meta}>`;
    })
    .join('\n');

  return `<!DOCTYPE html>
  <html lang="${lang}">
  <head>
    ${metaStr}
    <meta name="version" content="${version}">
    <ti>${title}</ti
    tle>
  </head>
  <body>
  <div id="root">
  </div>
  </body>
  ${content}
  </html>
  `;
};
